----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    21:51:38 09/09/2015 
-- Design Name: 
-- Module Name:    bussel - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity bussel is
    Port ( sram_din : in  STD_LOGIC_VECTOR (7 downto 0);
           sram_sel : in  STD_LOGIC;
			  memcon_din : in  STD_LOGIC_VECTOR (7 downto 0);
           memcon_sel : in  STD_LOGIC;
			  urat_din : in  STD_LOGIC_VECTOR (7 downto 0);
           uart_sel : in  STD_LOGIC;
           vdp_din : in  STD_LOGIC_VECTOR (7 downto 0);
           vdp_sel : in  STD_LOGIC;
           vram_din : in  STD_LOGIC_VECTOR (7 downto 0);
           vram_sel : in  STD_LOGIC;
           flash_din : in  STD_LOGIC_VECTOR (7 downto 0);
           flash_sel : in  STD_LOGIC;
           psg_din : in  STD_LOGIC_VECTOR (7 downto 0);
           psg_sel : in  STD_LOGIC;
           dc_din : in  STD_LOGIC_VECTOR (31 downto 0);
           dc_selb : in  STD_LOGIC_VECTOR (3 downto 0);
           dc_sel : in  STD_LOGIC;
           mcu_data_out : out  STD_LOGIC_VECTOR (7 downto 0));
end bussel;

architecture Behavioral of bussel is

begin
	process (memcon_din,memcon_sel,vdp_din,vdp_sel,psg_din,
		psg_sel,flash_sel,vram_sel,sram_din,vram_din,flash_din,uart_sel,urat_din,
		dc_din,dc_sel
		)
	begin
		if (memcon_sel='1') then mcu_data_out<=memcon_din;
		else if (dc_sel='1' and dc_selb(3)='1' ) then mcu_data_out<=dc_din(31 downto 24);
		else if (dc_sel='1' and dc_selb(2)='1' ) then mcu_data_out<=dc_din(23 downto 16);
		else if (psg_sel='1') then mcu_data_out<=psg_din;
		else if (vram_sel='1') then mcu_data_out<=vram_din;
		else if (flash_sel='1') then mcu_data_out<=flash_din;
		else if (uart_sel='1') then mcu_data_out<=urat_din;
		else if (vdp_sel='1') then mcu_data_out<=vdp_din;
			else mcu_data_out<=sram_din;
		end if;
		end if;
		end if;
		end if;
		end if;
		end if;
		end if;
		end if;
	end process;
end Behavioral;

